unit DialogsE;

{$O+,F+,X+,I-,S-}

interface

uses Objects, Drivers, Views, Dialogs;

type
  PMyFrame= ^TMyFrame;
  TMyFrame= Object(TFrame)
  constructor Init(var Bounds: TRect;Clc:word);
  procedure HandleEvent(var Event:TEvent);virtual;
  private
  CloseCF: word;
  End;

  PMyWindow = ^TMyWindow;
  TMyWindow = object (TWindow)
  constructor Init(var Bounds: TRect; ATitle: TTitleStr;
  ANumber: Integer;Clc:word);
  procedure InitFrame2(Clc:word);
  end;

  PDialogE = ^TDialogE;
  TDialogE = object(TMyWindow)
    constructor Init(var Bounds: TRect; ATitle: TTitleStr; Clc:word);
    constructor Load(var S: TStream);
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    function Valid(Command: Word): Boolean; virtual;
  end;

{ TSItem }

procedure RegisterDialogsE;

{ Stream Registration Records }

const
  RDialogE: TStreamRec = (
     ObjType: 1111;
     VmtLink: Ofs(TypeOf(TDialogE)^);
     Load:    @TDialogE.Load;
     Store:   @TDialogE.Store
  );

implementation

constructor TMyFrame.Init(var Bounds: TRect; Clc:word);
begin
  inherited Init(Bounds);
  CloseCF:=Clc;
end;

constructor TMyWindow.Init(var Bounds: TRect; ATitle: TTitleStr;
  ANumber: Integer; Clc:word);
begin
  TGroup.Init(Bounds);
  State := State or sfShadow;
  Options := Options or (ofSelectable + ofTopSelect);
  GrowMode := gfGrowAll + gfGrowRel;
  Flags := wfMove + wfGrow + wfClose + wfZoom;
  Title := NewStr(ATitle);
  Number := ANumber;
  Palette := wpBlueWindow;
  InitFrame2(Clc);
  if Frame <> nil then Insert(Frame);
  GetBounds(ZoomRect);
end;

procedure TMyFrame.HAndleEvent;
var Mouse : TPoint;
    R: TRect;
begin
    TView.HandleEvent(Event);
    if (Event.What= evMouseDown) and (State and sfActive<>0) then
      begin
      MakeLocal(Event.Where,Mouse);
      if Mouse.Y = 0 then
 begin
 if (PWindow(Owner)^.Flags and wfClose<>0) and
 (Mouse.X>=2) and (Mouse.X <=4) then
 begin
            Event.What := evCommand;
            Event.Command := CloseCF;
            Event.InfoPtr := nil;
            PutEvent(Event);
            ClearEvent(Event);
      end;
    end;
  end;
  inherited HAndleEvent(Event);
end; { HandleEvent }

procedure TMyWindow.InitFrame2(Clc:word);
var R: TRect;
begin
   GetExtent(R);
   Frame:= New(PMyFrame,Init(R,ClC));
end;

function IsBlank(Ch: Char): Boolean;
begin
  IsBlank := (Ch = ' ') or (Ch = #13) or (Ch = #10);
end;

constructor TDialogE.Init(var Bounds: TRect; ATitle: TTitleStr; Clc:word);
begin
  inherited Init(Bounds, ATitle, wnNoNumber,Clc);
  Options := Options or ofVersion20;
  GrowMode := 0;
  Flags := wfMove + wfClose;
  Palette := dpGrayDialog;
end;

constructor TDialogE.Load(var S: TStream);
begin
  inherited Load(S);
  if Options and ofVersion = ofVersion10 then
  begin
    Palette := dpGrayDialog;
    Inc(Options, ofVersion20);
  end;
end;

function TDialogE.GetPalette: PPalette;
const
  P: array[dpBlueDialog..dpGrayDialog] of string[Length(CBlueDialog)] =
    (CBlueDialog, CCyanDialog, CGrayDialog);
begin
  GetPalette := @P[Palette];
end;

procedure TDialogE.HandleEvent(var Event: TEvent);
begin
  TWindow.HandleEvent(Event);
  case Event.What of
    evKeyDown:
      case Event.KeyCode of
        kbEsc:
          begin
            Event.What := evCommand;
            Event.Command := cmCancel;
            Event.InfoPtr := nil;
            PutEvent(Event);
            ClearEvent(Event);
          end;
        kbEnter:
          begin
            Event.What := evBroadcast;
            Event.Command := cmDefault;
            Event.InfoPtr := nil;
            PutEvent(Event);
            ClearEvent(Event);
          end;
      end;
    evCommand:
      case Event.Command of
        cmOk, cmCancel, cmYes, cmNo:
          if State and sfModal <> 0 then
          begin
            EndModal(Event.Command);
            ClearEvent(Event);
          end;
      end;
  end;
end;

function TDialogE.Valid(Command: Word): Boolean;
begin
  if Command = cmCancel then Valid := True
  else Valid := TGroup.Valid(Command);
end;

{ Dialogs registration procedure }

procedure RegisterDialogsE;
begin
  RegisterType(RDialogE);
end;

end.

